package component.student

import react.FC
import react.Props
import react.dom.html.ReactHTML.button
import react.dom.html.ReactHTML.div
import react.dom.html.ReactHTML.input
import react.dom.html.ReactHTML.label
import react.useRef
import ru.altmanea.webapp.data.Student
import web.html.HTMLInputElement

external interface AddStudentProps: Props {
    var addStudent: (Student) -> Unit
}

val CAddStudent = FC<AddStudentProps>("AddStudent"){ props ->
    val firstnameRef = useRef<HTMLInputElement>()
    val surnameRef = useRef<HTMLInputElement>()
    div {
        div {
            label { +"firstname " }
            input { ref = firstnameRef }
        }
        div {
            label { +"surname " }
            input { ref = surnameRef }
        }
        button {
            +"Add"
            onClick = {
                firstnameRef.current?.value?.let { firstname ->
                    surnameRef.current?.value?.let { surname ->
                        props.addStudent(Student(firstname, surname))
                    }
                }
            }
        }
    }
}